<script lang="ts">
	import { Icon } from '@higenku/theme';

	export let logo: string = '/favicon.jpg';
	export let title: string;

	export let feedbackUrl: boolean = false;
	export let docsUrl: string | null = null;
	export let siteUrl: string | null = null;
	export let sourceUrl: string | null = null;

	export let state: 'wip' | 'alpha' | 'future' | 'none' | 'stable';

	const sourceBase = 'https://gitlab.com/higenku/';
	const domain = 'higenku.org';

	function getFeedbackSite(category = 'feedback') {
		return `https://community.higenku.org/t/${category}`;
	}

	function getDocsUrl(path: string) {
		return `https://docs.higenku.org/?go=${path}`;
	}

	function addsubdomain(subdomain: string | null = null) {
		if (subdomain) {
			return `https://${subdomain}.${domain}/`;
		} else {
			return `https://${domain}/`;
		}
	}
</script>

<div class="card  d-flex flex-col justify-between">
	<div class="d-flex flex-row items-start gap-0_5" style="flex-wrap: nowrap;">
		<Icon name={logo} classes="avatar avatar-squared" variant="higenku" size="lg" />
		<h4 style="margin-top: 0; margin-bottom: 0;" class="">
			{title}

			{#if state == 'wip'}
				<span class="badge warn">WIP</span>
			{:else if state == 'alpha'}
				<span class="badge succ">Alpha</span>
			{:else if state == 'future'}
				<span class="badge info">Future</span>
			{/if}
		</h4>
	</div>
	<p class="my-1">
		<slot />
	</p>
	<div class="d-flex flex-row items-center gap-1">
		{#if sourceUrl != null}
			<a href="{sourceBase}{sourceUrl}" target="_blank">Source Code</a>
		{/if}

		{#if docsUrl != null}
			<a href={getDocsUrl(docsUrl)} target="_blank">Docs</a>
		{/if}

		{#if siteUrl != null}
			<a href={addsubdomain(siteUrl)} target="_blank">Site</a>
		{/if}

		{#if feedbackUrl}
			<a href={getFeedbackSite()} target="_blank">Feedback</a>
		{/if}
	</div>
</div>
